<*+M2EXTENSIONS *>
<*+STORAGE *>
<*-GENFRAME*>
<*+NOPTRALIAS*>
<*+COMMENT*>
<* IF __GEN_C__ THEN *>
  <*+GENCTYPES*>
<* END *>


IMPLEMENTATION MODULE osi; (* os interface linux/win32 *)


<* IF TARGET_FAMILY="UNIX" THEN *>

FROM InOut IMPORT WriteLn, WriteString;
FROM StdChans IMPORT StdOutChan;
FROM fcntl IMPORT creat, open;
FROM IOChan IMPORT ChanId;
FROM RealIO IMPORT WriteFixed;
FROM unistd IMPORT read, write, close, lseek, SEEK_SET, SEEK_CUR;
FROM SYSTEM IMPORT ADR, CAST, CARD16, SHIFT, ADDRESS, ADDADR, BYTE;
--FROM Storage IMPORT ALLOCATE, DEALLOCATE;
--FROM Select IMPORT fdsetr, fdsetw;
--FROM aprsstr IMPORT IntToStr, Append, Length;
IMPORT FileSys;
FROM filesize IMPORT LSeek;

VAR
    cid : ChanId;

PROCEDURE WrLn();
BEGIN WriteLn; Flush END WrLn;

PROCEDURE WrStrLn(s:ARRAY OF CHAR);
BEGIN WriteString(s); WrLn END WrStrLn;

PROCEDURE WrFixed(x:REAL; place:INTEGER; witdh:CARDINAL);
BEGIN WriteFixed(cid, x, place, witdh) END WrFixed;

PROCEDURE WrHex(n, f:CARDINAL);
  PROCEDURE h(n:CARDINAL);
  BEGIN IF n<10 THEN WrStr(CHR(n+ORD("0"))) ELSE WrStr(CHR(n-10+ORD("A"))) END; END h;
BEGIN
  h(n DIV 16 MOD 16);
  h(n MOD 16);
  WHILE f>=3 DO WrStr(" "); DEC(f) END;
END WrHex;

(*
PROCEDURE OpenMode(name:ARRAY OF CHAR; mode:INTEGER):File;
BEGIN
  IF (name[0] = '-') AND ((HIGH(name) = 0) OR (name[1] = CHR(0))) THEN RETURN 0 END;
  RETURN open(name, mode)
END OpenMode;

--PROCEDURE Create(name:ARRAY OF CHAR):File;
--BEGIN RETURN creat(name, 644B) END Create;

PROCEDURE OpenAppend(fn:ARRAY OF CHAR):File;
BEGIN RETURN OpenMode(fn, oWRONLY+oAPPEND+oLARGEFILE) END OpenAppend;

PROCEDURE OpenWrite(fn:ARRAY OF CHAR):File;
BEGIN RETURN creat(fn, 644B) END OpenWrite;

PROCEDURE OpenRead(fn:ARRAY OF CHAR):File;
BEGIN RETURN OpenMode(fn, oRDONLY+oLARGEFILE) END OpenRead;

PROCEDURE OpenRW(fn:ARRAY OF CHAR):File;
BEGIN RETURN OpenMode(fn, oRDWR) END OpenRW;
*)

PROCEDURE OpenAppend(fn:ARRAY OF CHAR):File;
BEGIN RETURN open(fn, oWRONLY+oAPPEND+oLARGEFILE) END OpenAppend;

PROCEDURE OpenWrite(fn:ARRAY OF CHAR):File;
BEGIN RETURN creat(fn, 644B) END OpenWrite;

PROCEDURE OpenRead(fn:ARRAY OF CHAR):File;
BEGIN RETURN open(fn, oRDONLY+oLARGEFILE) END OpenRead;

PROCEDURE OpenRW(fn:ARRAY OF CHAR):File;
BEGIN RETURN open(fn, oRDWR) END OpenRW;





PROCEDURE FdValid(fd:File):BOOLEAN;
BEGIN RETURN fd>=0 END FdValid;

PROCEDURE Close(fd: File);
VAR res:INTEGER;
BEGIN res:=close(fd) END Close;

PROCEDURE CloseSock(fd: INTEGER);
VAR res:INTEGER;
BEGIN res:=close(fd) END CloseSock;


PROCEDURE RdBin(fd: File; VAR buf:ARRAY OF BYTE; size:CARDINAL):INTEGER;
BEGIN
  IF size>HIGH(buf)+1 THEN size:=HIGH(buf)+1 END;
  RETURN read(fd, ADR(buf), size)
END RdBin;

PROCEDURE WrBin(fd:File; VAR buf:ARRAY OF BYTE; size:CARDINAL);
VAR res:INTEGER;
BEGIN
  IF size>HIGH(buf)+1 THEN size:=HIGH(buf)+1 END;
  res:=write(fd, ADR(buf), size);
END WrBin;

PROCEDURE Rename(fname,newname: ARRAY OF CHAR);
VAR ok:BOOLEAN;
BEGIN
  FileSys.Rename(fname, newname, ok);
END Rename;

(*
PROCEDURE Size(fd:File):CARDINAL;
VAR st:stat.stat_t;
BEGIN
  stat.fstat(fd, st);
  RETURN st.st_size
END Size;
*)


PROCEDURE Seek(fd:File; pos:CARDINAL);
VAR res:INTEGER;
BEGIN
  res:=lseek(fd, pos, SEEK_SET);
END Seek;

PROCEDURE Seekcur(fd:File; rel:INTEGER);
BEGIN
  IF LSeek(fd, rel, SEEK_CUR)<0 THEN lseek(fd, 0, SEEK_SET) END;
END Seekcur;


BEGIN
  cid:=StdOutChan();





















<* ELSIF TARGET_FAMILY="WIN32" THEN *>

FROM InOut IMPORT WriteString, WriteCard, WriteInt, WriteLn;
FROM IOChan IMPORT ChanId;
FROM StdChans IMPORT StdOutChan;
FROM RealIO IMPORT WriteFixed;
FROM SYSTEM IMPORT ADR, CAST, INT16, CARD8, SHIFT, ADDRESS, ADDADR, BYTE, FILL;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
(*FROM Select IMPORT selectrwt, fdclr, fdsetr, fdsetw, issetr, issetw;*)
FROM aprsstr IMPORT IntToStr, Append, Length, StrToCard;
FROM unistd IMPORT lseek;

FROM Lib IMPORT ParamCount, ParamStr;
FROM Windows    IMPORT HWND,UINT,WPARAM,LPARAM,LRESULT,HBRUSH, CALLBACK, HDC, WM_CREATE,
                       WM_CLOSE,WM_DESTROY, CS_SET, CS_OWNDC, MB_SYSTEMMODAL,
                       IDI_APPLICATION,IDC_ARROW,COLOR_WINDOW,SW_SHOWNORMAL,
                       WS_EX_CLIENTEDGE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
                       WNDCLASS,MSG, WM_PAINT, PAINTSTRUCT,EndPaint, BeginPaint,
                       BITMAPV4HEADER, BITMAPINFOHEADER, LOWORD, HIWORD,
                       DestroyWindow,PostQuitMessage,DefWindowProc,
                       RegisterClass,CreateWindowEx, CreateWindow,SendMessage,
                       ShowWindow,UpdateWindow, GetModuleHandle,SetDIBitsToDevice,DIB_RGB_COLORS,
                       GetMessage,TranslateMessage,DispatchMessage,
                       WM_LBUTTONDOWN,WM_RBUTTONDOWN,WM_MBUTTONDOWN,WM_MBUTTONUP,
                       WM_MOUSEMOVE,WM_TIMER,WM_CHAR,WM_KEYDOWN,WM_KEYUP,WM_MOUSEWHEEL,
                       WM_LBUTTONUP,KillTimer,LoadCursor,LoadIcon,CreateSolidBrush,RGB,BI_RGB,
                       GetDC,ReleaseDC, MessageBox,MB_ICONEXCLAMATION,MB_OK, SetTimer,
                       GetClientRect, RECT, WM_SIZE, SetWindowText,
                       WSAAsyncSelect,FD_CONNECT,FD_CLOSE,FD_READ,FD_WRITE,
                       IDC_HAND, SetCursor, HCURSOR, WSAGetLastError,
                       SetFilePointer, FILE_BEGIN, FILE_CURRENT, FILE_END, HANDLE, ReadFile,
                       WriteFile,
                       CreateFile, GENERIC_READ, GENERIC_WRITE, OPEN_EXISTING, OPEN_ALWAYS,
                       FILE_SHARE_READ, FILE_SHARE_WRITE, FILE_SHARE_DELETE,
                       CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, FILE_APPEND_DATA,
                       INVALID_HANDLE_VALUE, CloseHandle, GetFileSize;

FROM WinSock IMPORT closesocket, p_hostent, gethostbyname, WSAStartup, WSADATA,
                    socket, sockaddr_in, AF_INET, SOCK_STREAM, IPPROTO_TCP, connect,
                    recv, sockaddr, ioctlsocket, FIONBIO, htons, htonl, send, bind,
                    recvfrom, ntohs, ntohl, sendto, SOCK_DGRAM;

VAR
    cid: ChanId;
    netstarted, usestdio:BOOLEAN;
    argc: CARDINAL;

PROCEDURE WrStr(s:ARRAY OF CHAR);
BEGIN
  IF usestdio THEN WriteString(s) END;
EXCEPT
END WrStr;

PROCEDURE WrCard(n, f:CARDINAL);
BEGIN
  IF usestdio THEN WriteCard(n, f) END;
EXCEPT
END WrCard;

PROCEDURE WrInt(n, f:CARDINAL);
BEGIN
  IF usestdio THEN WriteInt(n, f) END;
EXCEPT
END WrInt;

PROCEDURE WrLn();
BEGIN
  IF usestdio THEN WriteLn END;
EXCEPT
END WrLn;

PROCEDURE WrStrLn(s:ARRAY OF CHAR);
BEGIN 
  IF usestdio THEN
    WriteString(s);
    WrLn;
  END;
EXCEPT
END WrStrLn;

PROCEDURE WrFixed(x:REAL; place:INTEGER; witdh:CARDINAL);
BEGIN 
  IF usestdio THEN WriteFixed(cid, x, place, witdh) END;
EXCEPT
END WrFixed;

PROCEDURE WrHex(n, f:CARDINAL);
  PROCEDURE h(n:CARDINAL);
  BEGIN IF n<10 THEN WrStr(CHR(n+ORD("0"))) ELSE WrStr(CHR(n-10+ORD("A"))) END; END h;
BEGIN
  h(n DIV 16 MOD 16);
  h(n MOD 16);
  WHILE f>=3 DO WrStr(" "); DEC(f) END;
END WrHex;

PROCEDURE FdValid(fd:File):BOOLEAN;
BEGIN RETURN fd<>InvalidFd END FdValid;

PROCEDURE floor(x:REAL):REAL;
BEGIN RETURN VAL(REAL,VAL(INTEGER,x)) END floor;

PROCEDURE startnet;
VAR wsa:WSADATA;
BEGIN
  IF NOT netstarted THEN netstarted:=WSAStartup(514, wsa)=0 END;
END startnet;


PROCEDURE CloseSock(fd: SOCKET);
VAR res:INTEGER;
BEGIN res:=closesocket(fd) END CloseSock;

PROCEDURE readsock(fd:SOCKET; VAR buf:ARRAY OF CHAR; len:INTEGER):INTEGER;
VAR res:INTEGER;
BEGIN
  res:=recv(fd, buf, len, 0);
-- IF res>=0 THEN WrInt(res, 1); WrStrLn(" recv"); END;

  IF res=0 THEN res:=-1;
  ELSIF res<0 THEN res:=0 END;
  RETURN res
END readsock;

PROCEDURE sendsock(fd:SOCKET; VAR buf:ARRAY OF CHAR; len:INTEGER):INTEGER;
VAR ret, err:INTEGER;
BEGIN 
  ret:=send(fd, buf, len, 0);
  RETURN ret
END sendsock;


PROCEDURE connectto(VAR url,port:ARRAY OF CHAR):SOCKET;
VAR h:p_hostent;
    s:SOCKET;
    sa:sockaddr_in;
    res:INTEGER;
    nonbl:INTEGER;
    ipnum:POINTER TO CARDINAL;
    pnum:CARDINAL;
BEGIN
  IF NOT StrToCard(port, pnum) THEN RETURN CAST(SOCKET,-1) END;
  startnet;
  h:=gethostbyname(url);
  IF (h=NIL) OR (h^.h_addr_list=NIL) OR (h^.h_length<4) THEN RETURN CAST(SOCKET,-1) END;
  
  ipnum:=CAST(ADDRESS, h^.h_addr_list^);
  s:=socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
  IF s<0 THEN RETURN CAST(SOCKET,-1) END;

  nonbl:=1;
  IF ioctlsocket(s, CAST(INTEGER, FIONBIO), ADR(nonbl))<>0 THEN RETURN CAST(SOCKET,-1) END;

--  WSAAsyncSelect(s, hwndg, WM_SOCKET, CAST(CARDINAL, FD_CONNECT+FD_CLOSE+FD_READ+FD_WRITE));


  FILL(ADR(sa), 0C, SIZE(sa));

  sa.sin_family:=AF_INET;
  sa.sin_port:=htons(pnum);
  sa.sin_addr.s_addr:=ipnum^;

  res:=connect(s, CAST(sockaddr, sa), SIZE(sa));
  RETURN s
END connectto;

PROCEDURE openudp():SOCKET;
VAR s:SOCKET;
    nonbl:INTEGER;
BEGIN
  startnet;
  s:=socket(AF_INET, SOCK_DGRAM, 0);
  IF s=CAST(SOCKET, -1) THEN RETURN s END;

  nonbl:=1;
  IF ioctlsocket(s, CAST(INTEGER, FIONBIO), ADR(nonbl))<>0 THEN RETURN CAST(SOCKET, -1) END;
  RETURN s
END openudp;

PROCEDURE bindudp(fd:SOCKET; port:CARDINAL):INTEGER;
VAR 
    sa:sockaddr_in;
    res:INTEGER;
    nonbl:INTEGER;
BEGIN
  FILL(ADR(sa), 0C, SIZE(sa));

  sa.sin_family:=AF_INET;
  sa.sin_port:=htons(port);
  sa.sin_addr.s_addr:=0;

  res:=bind(fd, CAST(sockaddr, sa), SIZE(sa));
--WrInt(fd, 10);WrInt(res, 10);WrInt(port, 10);WrStrLn(" bindu");
  RETURN res
END bindudp;

PROCEDURE socknonblock(fd:SOCKET):INTEGER;
BEGIN
  RETURN -1
END socknonblock;

PROCEDURE udpreceive(fd:SOCKET; VAR data:ARRAY OF CHAR; len:INTEGER; VAR fromport, fromip:CARDINAL):INTEGER;
VAR sai:sockaddr_in;
    sa:sockaddr;
    alen, res:INTEGER;
BEGIN
  alen:=SIZE(sa);
  res:=recvfrom(fd, data, len, 0, sa, alen);
  sai:=CAST(sockaddr_in, sa);
  fromport:=ntohs(sai.sin_port);
  fromip:=ntohl(sai.sin_addr.s_addr);
--IF res>=0 THEN WrInt(res, 10);WrInt(fromport, 10);WrInt(fromip, 10);WrStrLn(" udpin"); END;
  RETURN res
END udpreceive;

PROCEDURE udpsend(fd:INTEGER; VAR data:ARRAY OF CHAR; len:INTEGER; toport, toip:CARDINAL):INTEGER;
VAR sai:sockaddr_in;
    sa:sockaddr;

    res:INTEGER;
BEGIN
  FILL(ADR(sai), 0C, SIZE(sai));
  sai.sin_family:=AF_INET;
  sai.sin_port:=htons(toport);
  sai.sin_addr.s_addr:=htonl(toip);
  sa:=CAST(sockaddr, sai);

  RETURN sendto(fd, data, len, 0, sa, SIZE(sa));
END udpsend;

PROCEDURE getunack(fd:INTEGER):INTEGER;            (* dummy, not possible in this os *)
BEGIN RETURN -1 END getunack;

PROCEDURE stoptxrx(fd, how:INTEGER);               (* dummy, not functional on this os *)
BEGIN END stoptxrx;



PROCEDURE NextArg(VAR s:ARRAY OF CHAR);
BEGIN
  IF argc>=ParamCount() THEN s[0]:=0C ELSE INC(argc); ParamStr(s, argc) END;
END NextArg;

PROCEDURE OpenAppend(fn:ARRAY OF CHAR):File;
BEGIN RETURN CreateFile(fn, FILE_APPEND_DATA, FILE_SHARE_READ+FILE_SHARE_WRITE+FILE_SHARE_DELETE,
                        NIL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NIL)  END OpenAppend;

PROCEDURE OpenWrite(fn:ARRAY OF CHAR):File;
BEGIN RETURN CreateFile(fn, GENERIC_WRITE, FILE_SHARE_READ+FILE_SHARE_WRITE+FILE_SHARE_DELETE,
                        NIL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NIL) END OpenWrite;

PROCEDURE OpenRead(fn:ARRAY OF CHAR):File;
BEGIN RETURN CreateFile(fn, GENERIC_READ, FILE_SHARE_READ+FILE_SHARE_WRITE+FILE_SHARE_DELETE,
                       NIL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NIL)  END OpenRead;

PROCEDURE OpenRW(fn:ARRAY OF CHAR):File;
BEGIN RETURN CreateFile(fn, GENERIC_READ+GENERIC_WRITE, FILE_SHARE_READ+FILE_SHARE_WRITE+FILE_SHARE_DELETE,
                       NIL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NIL)  END OpenRW;


PROCEDURE Close(fd: File);
VAR res:INTEGER;
BEGIN CloseHandle(fd) END Close;

PROCEDURE RdBin(fd: File; VAR buf:ARRAY OF BYTE; size:CARDINAL):INTEGER;
VAR rb:CARDINAL;
BEGIN
  IF size>HIGH(buf)+1 THEN size:=HIGH(buf)+1 END;
  IF ReadFile(fd, buf, size, rb, NIL) THEN RETURN rb END;
  RETURN -1
END RdBin;

PROCEDURE WrBin(fd:File; VAR buf:ARRAY OF BYTE; size:CARDINAL);
VAR wb:CARDINAL;
BEGIN
  IF size>HIGH(buf)+1 THEN size:=HIGH(buf)+1 END;
  WriteFile(fd, buf, size, wb, NIL);
END WrBin;


PROCEDURE SizeL(fd:File; VAR lo:CARDINAL; VAR hi:CARDINAL);
BEGIN
  lo:=GetFileSize(fd, hi);
END SizeL;

PROCEDURE Size(fd:File):CARDINAL;
VAR lo, hi:CARDINAL;
BEGIN
  SizeL(fd, lo, hi);
  RETURN lo
END Size;

PROCEDURE Seek(fd:File; pos:CARDINAL);
VAR hi:INTEGER;
BEGIN
  hi:=0;
  SetFilePointer(fd, pos, hi, FILE_BEGIN);
END Seek;

PROCEDURE Seekcur(fd:File; rel:INTEGER);
VAR lo, hi:CARDINAL;
    hii:INTEGER;
BEGIN
--WrInt(rel, 15); WrStrLn("=rel");
  IF rel<0 THEN
     hii:=0;
     lo:=SetFilePointer(fd, 0, hii, FILE_CURRENT);
--WrInt(lo, 15); WrInt(hii, 15); WrStrLn("=lo hi null");
     IF (hii=0) & (VAL(CARDINAL,-rel)>=lo) THEN Seek(fd, 0); RETURN END;

     hii:=-1;
  ELSE hii:=0 END;
--WrInt(hii, 15); WrInt(rel, 15); WrStrLn("=hii rel");

  SetFilePointer(fd, rel, hii, FILE_CURRENT);
END Seekcur;

PROCEDURE STDIO(on:BOOLEAN);
BEGIN
   usestdio:=on;
   IF usestdio THEN cid:=StdOutChan() END;
END STDIO; 

BEGIN
--  cid:=StdOutChan();
  usestdio:=FALSE; 
  InvalidFd:=INVALID_HANDLE_VALUE;
  argc:=0;
  netstarted:=FALSE;

<* END *>

END osi.

(* timerevent with time not select timeout, gateconn with timer*)
(*
# crlf in files
# image size + framesize
# set timer only if time change
copy/paste
# create
# save bmp not ppm
# no cfg at start?
# hints + mouseqth
# resize
# window title x y
link png
# show x y of inside window
# screenshot y size -2
# start xy size wrong
32bit pixel=x11
*)